﻿varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform lowp sampler2D samplerBack;
uniform mediump vec2 srcStart;
uniform mediump vec2 srcEnd;
uniform mediump vec2 destStart;
uniform mediump vec2 destEnd;

void main(void)
{
	// input color.
	mediump vec2 n = (vTex - srcStart) / (srcEnd - srcStart);
	lowp vec4 back = texture2D(samplerBack, mix(destStart, destEnd, n));

	// pen color.
	lowp vec4 front = texture2D(samplerFront, vTex);
	
	// combine the input and paper colors.
	gl_FragColor = back.r == 1.0 && back.g == 1.0 && back.b == 1.0 ? front : back;
}
